<?php
/**
 * Copyright © 2015 Infomodus. All rights reserved.
 */

namespace Infomodus\Upslabel\Controller\Adminhtml\Items;

class Autoprint extends \Infomodus\Upslabel\Controller\Adminhtml\Items
{
    protected $_handy;

    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Magento\Framework\Registry $coreRegistry,
        \Magento\Backend\Model\View\Result\ForwardFactory $resultForwardFactory,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Infomodus\Upslabel\Helper\Handy $handy
    )
    {
        parent::__construct($context, $coreRegistry, $resultForwardFactory, $resultPageFactory);
        $this->_handy = $handy;
    }

    public function execute()
    {
        $orderId = $this->getRequest()->getParam('order_id');
        $shipmentId = $this->getRequest()->getParam('shipment_id', NULL);
        $labelId = $this->getRequest()->getParam('label_id', NULL);
        $shipident_id = $this->getRequest()->getParam('shipident_id', NULL);
        $type = $this->getRequest()->getParam('type');
        $path = $this->_handy->_conf->getBaseDir('media') . '/upslabel/label/';

        /*multistore*/
        $order = $this->_objectManager->get('Magento\Sales\Model\OrderRepository')->get($orderId);
        $storeId = $order->getStoreId();
        /*multistore*/

        $upslabel = $this->_objectManager->get('Infomodus\Upslabel\Model\Items');
        if ($labelId === NULL) {
            $colls2 = $upslabel->getCollection()->addFieldToFilter('order_id', $orderId);
            if ($shipmentId !== NULL) {
                $colls2->addFieldToFilter('shipment_id', $shipmentId);
            }
            $colls2->addFieldToFilter('type', $type)->addFieldToFilter('status', 0);
            foreach ($colls2 AS $coll) {
                if (file_exists($path . ($coll->getLabelname()))) {
                    if ($data = file_get_contents($path . ($coll->getLabelname()))) {
                        $this->_handy->_conf->sendPrint($data/*multistore*/, $storeId/*multistore*/);
                    }
                }
            }
            echo __('Label was sent to print');
        } else if ($shipident_id !== NULL) {
            $colls2 = $upslabel->getCollection()->addFieldToFilter('shipmentidentificationnumber', $shipident_id);
            $colls2->addFieldToFilter('status', 0);
            foreach ($colls2 AS $coll) {
                if (file_exists($path . ($coll->getLabelname()))) {
                    if ($data = file_get_contents($path . ($coll->getLabelname()))) {
                        $this->_handy->_conf->sendPrint($data/*multistore*/, $storeId/*multistore*/);
                    }
                }
            }
            echo __('Label was sent to print');
        } else if ($labelId !== NULL) {
            $label = $upslabel->get($labelId);
            if (file_exists($path . ($label->getLabelname()))) {
                if ($data = file_get_contents($path . ($label->getLabelname()))) {
                    $this->_handy->_conf->sendPrint($data/*multistore*/, $storeId/*multistore*/);
                }
            }
            echo __('Label was sent to print');
        }
    }
}
