<?php
/*
 * Author Rudyuk Vitalij Anatolievich
 * Email rvansp@gmail.com
 * Blog www.cervic.info
 */
namespace Infomodus\Upslabel\Helper;

use Magento\Sales\Model\Order\Email\Sender\ShipmentSender;
use Magento\Sales\Model\Order\ShipmentFactory;

class Handy extends \Magento\Framework\App\Helper\AbstractHelper
{
    public $_context;
    public $objectManager;
    public $_conf;
    public $_registry;
    public $order = NULL;
    public $shipment;
    public $shipmentId = NULL;
    public $type;
    public $type2;
    public $paymentmethod;
    public $shipmentTotalPrice;
    public $shippingAddress;
    public $defConfParams;
    public $defPackageParams;
    public $shipByUps;
    public $shipByUpsCode;
    public $shipByUpsMethodName;
    public $upsAccounts;
    public $label = [];
    public $label2 = [];
    /*multistore*/
    public $storeId;
    /*multistore*/
    public $pickup;

    protected $shipmentFactory;
    protected $shipmentSender;
    protected $shipmentLoaderFactory;

    public $negotiatedRates;
    public $ratesTax;

    public function __construct(
        \Magento\Framework\App\Helper\Context $context,
        \Magento\Framework\ObjectManagerInterface $objectManager,
        \Infomodus\Upslabel\Helper\Config $config,
        \Magento\Shipping\Controller\Adminhtml\Order\ShipmentLoaderFactory $shipmentLoaderFactory,
        ShipmentSender $shipmentSender,
        ShipmentFactory $shipmentFactory,
        \Magento\Framework\Registry $registry
    )
    {
        $this->shipmentSender = $shipmentSender;
        $this->shipmentFactory = $shipmentFactory;
        $this->shipmentLoaderFactory = $shipmentLoaderFactory;
        $this->_registry = $registry;
        parent::__construct($context);
        $this->_context = $context;
        $this->objectManager = $objectManager;
        $this->_conf = $config;

    }


    public function intermediate($order, $type, $shipmentId = NULL)
    {
        $configMethod = new \Infomodus\Upslabel\Model\Config\Upsmethod;
        $this->defConfParams = array();
        $this->shipmentId = $shipmentId;
        unset($shipmentId);
        if ($order !== NULL) {
            if (!is_numeric($order)) {
                $this->order = $order;
            } else {
                $this->order = $this->objectManager->get('Magento\Sales\Model\Order')->load($order);
            }
        } else if ($this->shipmentId !== NULL) {
            if ($type !== 'refund') {
                $this->order = $this->objectManager->get('Magento\Sales\Model\Order\Shipment')->load($this->shipmentId)->getOrder();
            } else {
                $this->order = $this->shipment = $this->objectManager->get('Magento\Sales\Model\Order\Creditmemo')->load($this->shipmentId)->getOrder();
            }
        }
        unset($order);
        $this->type = $type;
        unset($type);

        /*multistore*/
        $this->storeId = $this->order->getStoreId();
        /*multistore*/

        $this->paymentmethod = $this->order->getPayment()->getData();
        $this->paymentmethod = $this->paymentmethod['method'];
        $this->shippingAddress = $this->order->getShippingAddress();
        if ($this->_conf->isModuleOutputEnabled("Infomodus_Upsap") && $this->_conf->getStoreConfig('carriers/upsap/active', $this->storeId) == 1) {
            $modelAccessPoint = $this->objectManager->get('Infomodus\Upsap\Model\Points')->getCollection()->addFieldToFilter('order_id', $this->order->getId())->getFirstItem()->getData();
            if (count($modelAccessPoint) > 0) {
                $this->shippingAddress = $this->order->getBillingAddress();
            }
        }

        if ($this->shipmentId !== NULL) {
            if ($this->type != 'refund') {
                $this->shipment = $this->objectManager->get('Magento\Sales\Model\Order\Shipment')->load($this->shipmentId);
            } else {
                $this->shipment = $this->objectManager->get('Magento\Sales\Model\Order\Creditmemo')->load($this->shipmentId);
            }
            $shipmentAllItems = $this->shipment->getAllItems();
        } else {
            $shipmentAllItems = $this->order->getAllVisibleItems();
        }
        $totalPrice = 0;
        $this->totalWeight = 0;
        $totalShipmentQty = 0;
        $this->sku = array();
        $pi = 1;
        foreach ($shipmentAllItems AS $item) {
            if(!$item->isDeleted() && !$item->getParentItemId()) {
                $itemData = $item->getData();
                $this->sku[] = $itemData['sku'];
                if (!isset($itemData['qty'])) {
                    $itemData['qty'] = $itemData['qty_ordered'];
                }
                if (!isset($itemData['weight'])) {
                    /*$wItems = $this->order->getAllVisibleItems();
                    foreach ($wItems AS $w) {
                        if ($w->getProductId() == $itemData["product_id"]) {
                            $itemData['weight'] = $w->getWeight();
                        }
                    }*/
                    continue;
                }
                $totalPrice += $itemData['price'] * $itemData['qty'];
                $this->totalWeight += $itemData['weight'] * $itemData['qty'];
                $totalShipmentQty += $itemData['qty'];
                if ($this->_conf->getStoreConfig('upslabel/paperless/enable', $this->storeId) == 1) {
                    $productOrigin = $this->objectManager->get('Magento\Catalog\Model\Product')->load($itemData["product_id"])->getData();
                    $commodityCode = trim($this->_conf->getStoreConfig('upslabel/paperless/international_commodity_id', $this->storeId));
                    $this->defConfParams['international_products'][] = array(
                        'enabled' => 1,
                        'description' => strlen($this->_conf->getStoreConfig('upslabel/paperless/product_description', $this->storeId)) > 0 ? $this->_conf->getStoreConfig('upslabel/paperless/product_description', $this->storeId) : $productOrigin['name'],
                        'country_code' => (isset($productOrigin['country_of_manufacture']) && $productOrigin['country_of_manufacture'] != '') ? $productOrigin['country_of_manufacture'] : $this->_conf->getStoreConfig('upslabel/paperless/product_origin_country', $this->storeId),
                        'qty' => isset($itemData['qty'])?(int)$itemData['qty']:1,
                        'amount' => isset($itemData['price'])?$itemData['price']:0,
                        'unit_of_measurement' => $this->_conf->getStoreConfig('upslabel/paperless/international_unitofmeasurement', $this->storeId),
                        'unit_of_measurement_desc' => $this->_conf->getStoreConfig('upslabel/paperless/international_unitofmeasurementdesc', $this->storeId),
                        'commoditycode' => ($commodityCode !== "" && isset($productOrigin[$commodityCode])) ? $productOrigin[$commodityCode] : "",
                        'partnumber' => $pi,
                    );
                }
                $pi++;
            }
        }
        $this->sku = implode(",", $this->sku);
        $totalQty = 0;
        foreach ($this->order->getAllVisibleItems() AS $item) {
            $itemData = $item->getData();
            $totalQty += $itemData['qty_ordered'];
        }
        $this->upsAccounts = array("Shipper");
        $upsAcctModel = $this->objectManager->get('Infomodus\Upslabel\Model\Resource\Account\Collection')->load();
        foreach ($upsAcctModel AS $u1) {
            $this->upsAccounts[$u1->getId()] = $u1->getCompanyname();
        }
        if (count($shipmentAllItems) != count($this->order->getAllVisibleItems()) && count($shipmentAllItems) != count($this->order->getAllItems())) {
            if($this->_conf->getStoreConfig('upslabel/ratepayment/cod_shipping_cost', $this->storeId)==0){
                $this->shipmentTotalPrice = $totalPrice;
            } else {
                $this->shipmentTotalPrice = $totalPrice + $this->order->getShippingAmount();
            }
        } else {
            if($this->_conf->getStoreConfig('upslabel/ratepayment/cod_shipping_cost', $this->storeId)==0){
                $this->shipmentTotalPrice = $this->order->getGrandTotal() - $this->order->getShippingAmount();
            } else {
                $this->shipmentTotalPrice = $this->order->getGrandTotal();
            }
        }
        $this->defConfParams['upsaccount'] = $this->_conf->getStoreConfig('upslabel/ratepayment/third_party', $this->storeId);

        $ship_method = $this->order->getShippingMethod();
        $shippingInternational = $this->shippingAddress->getCountryId() == $this->_conf->getStoreConfig('upslabel/address_' . $this->_conf->getStoreConfig('upslabel/shipping/defaultshipfrom', $this->storeId) . '/countrycode', $this->storeId) ? 0 : 1;
        $this->shipByUps = preg_replace("/^ups_.{1,4}$/", 'ups', $ship_method);

        if ($this->shipByUps == 'ups') {
            $this->shipByUpsCode = $configMethod->getUpsMethodNumber(preg_replace("/^ups_(.{2,4})$/", '$1', $ship_method));
            $this->shipByUpsMethodName = $configMethod->getUpsMethodName($this->shipByUpsCode);
            $this->defConfParams['serviceCode'] = $this->shipByUpsCode;
        } else if ($this->shipByUps = preg_replace("/^upsap_.{1,100}$/", 'upsap', $ship_method) == 'upsap') {
            $this->shipByUps = 'ups';
            $this->shipByUpsCode = explode("_", $ship_method);
            $this->shipByUpsCode = $this->shipByUpsCode[3];
            $this->defConfParams['serviceCode'] = $this->shipByUpsCode;
            $this->shipByUpsMethodName = $configMethod->getUpsMethodName($this->shipByUpsCode);
        } else if ($this->shipByUps = preg_replace("/^caship_.{1,100}$/", 'caship', $ship_method) == 'caship'
        && $this->shipByUpsCode = explode("_", $ship_method) && ($this->shipByUpsCode[2] == 'ups' || $this->shipByUpsCode[2] == 'upsinfomodus')
        ) {
                $this->shipByUps = 'ups';
                $this->shipByUpsCode = $this->shipByUpsCode[3];
                $this->defConfParams['serviceCode'] = $this->shipByUpsCode;
        } else if ($this->_conf->getStoreConfig('upslabel/shipping/shipping_method_native', $this->storeId) == 1) {
            $modelConformity = $this->objectManager->get('Infomodus\Upslabel\Model\Conformity')->getCollection()->addFieldToFilter('method_id', $ship_method)->addFieldToFilter('store_id', /*multistore*/
                $this->storeId ? $this->storeId : /*multistore*/
                    1)
                ->getSelect()->where('CONCAT(",", country_ids, ",") LIKE "%,' . $this->shippingAddress->getCountryId() . ',%"')->query()->fetch();
            if ($modelConformity && count($modelConformity) > 0) {
                $this->defConfParams['serviceCode'] = $modelConformity["upsmethod_id"];
            }
        }
        if (!isset($this->defConfParams['serviceCode'])) {
            $this->defConfParams['serviceCode'] = $shippingInternational == 0 ? $this->_conf->getStoreConfig('upslabel/shipping/defaultshipmentmethod', $this->storeId) : $this->_conf->getStoreConfig('upslabel/shipping/defaultshipmentmethodworld', $this->storeId);
        }

        if ($this->totalWeight <= 0) {
            $this->totalWeight = (float)str_replace(',', '.', $this->_conf->getStoreConfig('upslabel/weightdimension/defweigth', $this->storeId));
        }

        if (
            $this->type == 'shipment' && $this->_conf->getStoreConfig('upslabel/frontend_autocreate_label/frontend_multipackes_enable', $this->storeId) == 1
        ) {
            $i = 0;
            $defParArr_1 = array();
            foreach ($shipmentAllItems AS $item) {
                if(!$item->isDeleted() && !$item->getParentItemId()) {
                    $itemData = $item->getData();
                    if (!isset($itemData['qty'])) {
                        $itemData['qty'] = $itemData['qty_ordered'];
                    }
                    if (!isset($itemData['weight'])) {
                        foreach ($this->order->getAllVisibleItems() AS $w) {
                            if ($w->getProductId() == $itemData["product_id"]) {
                                $itemData['weight'] = $w->getWeight();
                            }
                        }
                    }
                    $myproduct = $this->objectManager->get('Magento\Catalog\Model\Product')->load($itemData['product_id'])->getData();
                    for ($ik = 0; $ik < $itemData['qty']; $ik++) {
                        $is_attribute = 0;
                        if ($this->_conf->getStoreConfig('upslabel/frontend_autocreate_label/packages_by_attribute_enable', $this->storeId) == 1) {
                            if (isset($myproduct[$this->_conf->getStoreConfig('upslabel/frontend_autocreate_label/packages_by_attribute_code', $this->storeId)])) {
                                $attribute = explode(";", trim($myproduct[$this->_conf->getStoreConfig('upslabel/frontend_autocreate_label/packages_by_attribute_code', $this->storeId)], ";"));
                                if (count($attribute) > 1) {
                                    $rvaPrice = $itemData['price'];
                                    foreach ($attribute AS $v) {
                                        $itemData['weight'] = $v;
                                        $itemData['price'] = round($rvaPrice / count($attribute), 2);
                                        $defParArr_1[$i] = $this->setPackageDefParams($itemData);
                                        $i++;
                                    }
                                    $is_attribute = 1;
                                }
                            }
                        }
                        if ($is_attribute !== 1) {
                            if (
                                $this->_conf->getStoreConfig('upslabel/frontend_autocreate_label/multipackes_attribute_width', $this->storeId) != ''
                                && $this->_conf->getStoreConfig('upslabel/frontend_autocreate_label/multipackes_attribute_height', $this->storeId) != ''
                                && $this->_conf->getStoreConfig('upslabel/frontend_autocreate_label/multipackes_attribute_length', $this->storeId) != ''
                            ) {
                                if (
                                    isset($myproduct[$this->_conf->getStoreConfig('upslabel/frontend_autocreate_label/multipackes_attribute_width', $this->storeId)])
                                    && isset($myproduct[$this->_conf->getStoreConfig('upslabel/frontend_autocreate_label/multipackes_attribute_height', $this->storeId)])
                                    && isset($myproduct[$this->_conf->getStoreConfig('upslabel/frontend_autocreate_label/multipackes_attribute_length', $this->storeId)])
                                ) {
                                    $itemData['width'] = $myproduct[$this->_conf->getStoreConfig('upslabel/frontend_autocreate_label/multipackes_attribute_width', $this->storeId)];
                                    $itemData['height'] = $myproduct[$this->_conf->getStoreConfig('upslabel/frontend_autocreate_label/multipackes_attribute_height', $this->storeId)];
                                    $itemData['length'] = $myproduct[$this->_conf->getStoreConfig('upslabel/frontend_autocreate_label/multipackes_attribute_length', $this->storeId)];
                                }
                            }
                            $defParArr_1[$i] = $this->setPackageDefParams($itemData);
                            $i++;
                        }
                    }
                }
            }
            $this->defPackageParams = $defParArr_1;
        } else {
            $this->defPackageParams = array();
            $i = 0;
            $rvaShipmentTotalPrice = $this->shipmentTotalPrice;
            if ($this->_conf->getStoreConfig('upslabel/frontend_autocreate_label/packages_by_attribute_enable', $this->storeId) == 1 && $this->type == 'shipment') {
                foreach ($shipmentAllItems AS $item) {
                    if(!$item->isDeleted() && !$item->getParentItemId()) {
                        $itemData = $item->getData();
                        if (!isset($itemData['qty'])) {
                            $itemData['qty'] = $itemData['qty_ordered'];
                        }
                        if (!isset($itemData['weight'])) {
                            foreach ($this->order->getAllVisibleItems() AS $w) {
                                if ($w->getProductId() == $itemData["product_id"]) {
                                    $itemData['weight'] = $w->getWeight();
                                }
                            }
                        }
                        $itemData2 = $itemData;
                        $myproduct = $this->objectManager->get('Magento\Catalog\Model\Product')->load($itemData['product_id'])->getData();
                        for ($ik = 0; $ik < $itemData['qty']; $ik++) {
                            if (isset($myproduct[$this->_conf->getStoreConfig('upslabel/frontend_autocreate_label/packages_by_attribute_code', $this->storeId)])) {
                                $attribute = explode(";", trim($myproduct[$this->_conf->getStoreConfig('upslabel/frontend_autocreate_label/packages_by_attribute_code', $this->storeId)], ";"));
                                if (count($attribute) > 1) {
                                    foreach ($attribute AS $v) {
                                        $this->totalWeight = $this->totalWeight - $itemData2['weight'];
                                        $itemData['price'] = round($itemData2['price'] / count($attribute), 2);
                                        $itemData['weight'] = $v;
                                        $this->defPackageParams[$i] = $this->setPackageDefParams($itemData);
                                        $i++;
                                    }
                                    $rvaShipmentTotalPrice = $rvaShipmentTotalPrice - $itemData2['price'];
                                }
                            }
                        }
                    }
                }
            }
            //if ($this->totalWeight > 0) {
                $this->defPackageParams[$i] = $this->setPackageDefParams(NULL);
            //}
        }

        $this->defConfParams['shipper_no'] = $this->_conf->getStoreConfig('upslabel/shipping/defaultshipper', $this->storeId);
        $this->defConfParams['shipfrom_no'] = $this->_conf->getStoreConfig('upslabel/shipping/defaultshipfrom', $this->storeId);
        $this->defConfParams['testing'] = $this->_conf->getStoreConfig('upslabel/testmode/testing', $this->storeId);
        $this->defConfParams['addtrack'] = $this->_conf->getStoreConfig('upslabel/shipping/addtrack', $this->storeId);
        if($this->_conf->getStoreConfig('upslabel/shipping/shipmentdescription', $this->storeId) != 4){
            $this->defConfParams['shipmentdescription'] = $this->_conf->getStoreConfig('upslabel/shipping/shipmentdescription', $this->storeId) == 1 ? ($this->shippingAddress->getFirstname() . ' ' . $this->shippingAddress->getLastname() . ', ' . $this->order->getIncrementId()) : ($this->_conf->getStoreConfig('upslabel/shipping/shipmentdescription', $this->storeId) == 2 ? $this->shippingAddress->getFirstname() . ' ' . $this->shippingAddress->getLastname() : ($this->_conf->getStoreConfig('upslabel/shipping/shipmentdescription', $this->storeId) !== '' ? __('Order Id') . ': ' . $this->order->getIncrementId() : ''));
        } else {
            $this->defConfParams['shipmentdescription'] = str_replace(array("#order_id#", "#customer_name#"), array($this->order->getIncrementId(), $this->shippingAddress->getFirstname() . ' ' . $this->shippingAddress->getLastname()), $this->_conf->getStoreConfig('upslabel/shipping/shipmentdescription_custom', $this->storeId));
        }
        $this->defConfParams['currencycode'] = $this->_conf->getStoreConfig('upslabel/ratepayment/currencycode', $this->storeId);
        $this->defConfParams['shipmentcharge'] = $this->_conf->getStoreConfig('upslabel/ratepayment/shipmentcharge', $this->storeId);
        $this->defConfParams['cod'] = $this->_conf->getStoreConfig('upslabel/ratepayment/cod', $this->storeId) == 1 ? 1 : (($this->paymentmethod == 'cashondelivery' || $this->paymentmethod == 'phoenix_cashondelivery') ? 1 : 0);
        $this->defConfParams['codmonetaryvalue'] = $this->shipmentTotalPrice;
        $this->defConfParams['codfundscode'] = 1;
        $this->defConfParams['invoicelinetotalyesno'] = $this->_conf->getStoreConfig('upslabel/ratepayment/invoicelinetotal', $this->storeId);
        $this->defConfParams['invoicelinetotal'] = $this->shipmentTotalPrice;
        $this->defConfParams['carbon_neutral'] = $this->_conf->getStoreConfig('upslabel/ratepayment/carbon_neutral', $this->storeId);
        $this->defConfParams['default_return'] = ($this->_conf->getStoreConfig('upslabel/return/default_return', $this->storeId) == 0 || $this->_conf->getStoreConfig('upslabel/return/default_return_amount', $this->storeId) > $this->shipmentTotalPrice) ? 0 : 1;
        $this->defConfParams['default_return_servicecode'] = $this->_conf->getStoreConfig('upslabel/return/default_return_method', $this->storeId);
        $this->defConfParams['qvn'] = $this->_conf->getStoreConfig('upslabel/quantum/qvn', $this->storeId);
        $this->defConfParams['qvn_code'] = explode(",", $this->_conf->getStoreConfig('upslabel/quantum/qvn_code', $this->storeId));
        $this->defConfParams['qvn_email_shipper'] = $this->_conf->getStoreConfig('upslabel/quantum/qvn_email_shipper', $this->storeId);
        $this->defConfParams['qvn_lang'] = $this->_conf->getStoreConfig('upslabel/quantum/qvn_lang', $this->storeId);
        $this->defConfParams['adult'] = $this->_conf->getStoreConfig('upslabel/quantum/adult', $this->storeId);
        $this->defConfParams['weightunits'] = $this->_conf->getStoreConfig('upslabel/weightdimension/weightunits', $this->storeId);
        $this->defConfParams['includedimensions'] = $this->_conf->getStoreConfig('upslabel/weightdimension/includedimensions', $this->storeId);
        $this->defConfParams['unitofmeasurement'] = $this->_conf->getStoreConfig('upslabel/weightdimension/unitofmeasurement', $this->storeId);
        $this->defConfParams['residentialaddress'] = strlen($this->shippingAddress->getCompany()) > 0 ? 0 : 1;
        $this->defConfParams['shiptocompanyname'] = strlen($this->shippingAddress->getCompany()) > 0 ? $this->shippingAddress->getCompany() : $this->shippingAddress->getFirstname() . ' ' . $this->shippingAddress->getLastname();
        $this->defConfParams['shiptoattentionname'] = $this->shippingAddress->getFirstname() . ' ' . $this->shippingAddress->getLastname();
        $this->defConfParams['shiptophonenumber'] = $this->shippingAddress->getTelephone();
        $addressLine1 = $this->shippingAddress->getStreet();
        $this->defConfParams['shiptoaddressline1'] = is_array($addressLine1) && array_key_exists(0, $addressLine1) ? $addressLine1[0] : $addressLine1;
        $this->defConfParams['shiptoaddressline2'] = (is_array($addressLine1) && isset($addressLine1[1])) ? $addressLine1[1] : '';
        $this->defConfParams['shiptocity'] = $this->shippingAddress->getCity();
        $this->defConfParams['shiptostateprovincecode'] = $this->shippingAddress->getRegion();
        $this->defConfParams['shiptopostalcode'] = $this->shippingAddress->getPostcode();
        $this->defConfParams['shiptocountrycode'] = $this->shippingAddress->getCountryId();
        $this->defConfParams['qvn_email_shipto'] = $this->shippingAddress->getEmail();
        $this->defConfParams['saturday_delivery'] = $this->_conf->getStoreConfig('upslabel/shipping/saturday_delivery', $this->storeId);
        $this->defConfParams['international_invoice'] = $this->_conf->getStoreConfig('upslabel/paperless/enable', $this->storeId);
        $this->defConfParams['international_comments'] = $this->_conf->getStoreConfig('upslabel/paperless/international_comments', $this->storeId);
        $this->defConfParams['international_invoicenumber'] = $this->order->getIncrementId();
        $this->defConfParams['international_invoicedate'] = date("Y-m-d", time());
        $this->defConfParams['international_reasonforexport'] = $this->_conf->getStoreConfig('upslabel/paperless/reasonforexport', $this->storeId);
        $this->defConfParams['international_purchaseordernumber'] = $this->order->getIncrementId();
        $this->defConfParams['international_termsofshipment'] = $this->_conf->getStoreConfig('upslabel/paperless/international_termsofshipment', $this->storeId);
        $this->defConfParams['international_sold_to'] = $this->_conf->getStoreConfig('upslabel/paperless/international_sold_to', $this->storeId);

        $this->defConfParams['accesspoint'] = 0;
        if ($this->_conf->getStoreConfig('carriers/upsap/active', $this->storeId) == 1 && $this->_conf->isModuleOutputEnabled("Infomodus_Upsap")) {
            if (count($modelAccessPoint) > 0) {
                $modelAccessPoint = json_decode($modelAccessPoint['address'], true);
                $this->defConfParams['accesspoint'] = 1;
                $this->defConfParams['accesspoint_type'] = $this->_conf->getStoreConfig('carriers/upsap/type', $this->storeId);
                $this->defConfParams['accesspoint_name'] = $modelAccessPoint['name'];
                $this->defConfParams['accesspoint_atname'] = $modelAccessPoint['name'];
                $this->defConfParams['accesspoint_appuid'] = $modelAccessPoint['appuId'];
                $this->defConfParams['accesspoint_street'] = $modelAccessPoint['addLine1'];
                if (isset($modelAccessPoint['addLine2'])) {
                    $this->defConfParams['accesspoint_street1'] = $modelAccessPoint['addLine2'];
                    if (isset($modelAccessPoint['addLine3'])) {
                        $this->defConfParams['accesspoint_street2'] = $modelAccessPoint['addLine3'];
                    }
                }
                $this->defConfParams['accesspoint_city'] = $modelAccessPoint['city'];
                $this->defConfParams['accesspoint_provincecode'] = $modelAccessPoint['state'];
                $this->defConfParams['accesspoint_postal'] = $modelAccessPoint['postal'];
                $this->defConfParams['accesspoint_country'] = $modelAccessPoint['country'];
            }
        }
        return true;
    }

    public
    function setPackageDefParams($itemData = NULL)
    {
        $defParArr_1['packagingtypecode'] = $this->_conf->getStoreConfig('upslabel/packaging/packagingtypecode');
        $defParArr_1['packagingdescription'] = $this->_conf->getStoreConfig('upslabel/packaging/packagingdescription', $this->storeId);
        $defParArr_1['packagingreferencenumbercode'] = $this->_conf->getStoreConfig('upslabel/packaging/packagingreferencenumbercode', $this->storeId);
        $defParArr_1['packagingreferencebarcode'] = $this->_conf->getStoreConfig('upslabel/packaging/packagingreferencebarcode', $this->storeId);
        $defParArr_1['packagingreferencenumbervalue'] = str_replace(array("#order_id#", "#customer_name#"), array($this->order->getIncrementId(), $this->shippingAddress->getFirstname() . ' ' . $this->shippingAddress->getLastname()), $this->_conf->getStoreConfig('upslabel/packaging/packagingreferencenumbervalue', $this->storeId));
        $defParArr_1['packagingreferencenumbercode2'] = $this->_conf->getStoreConfig('upslabel/packaging/packagingreferencenumbercode2', $this->storeId);
        $defParArr_1['packagingreferencebarcode2'] = $this->_conf->getStoreConfig('upslabel/packaging/packagingreferencebarcode2', $this->storeId);
        $defParArr_1['packagingreferencenumbervalue2'] = str_replace(array("#order_id#", "#customer_name#"), array($this->order->getIncrementId(), $this->shippingAddress->getFirstname() . ' ' . $this->shippingAddress->getLastname()), $this->_conf->getStoreConfig('upslabel/packaging/packagingreferencenumbervalue2', $this->storeId));
        $defParArr_1['weight'] = $itemData !== NULL ? $itemData['weight'] : $this->totalWeight;
        $defParArr_1['packweight'] = round((float)str_replace(',', '.', $this->_conf->getStoreConfig('upslabel/weightdimension/packweight', $this->storeId)), 1) > 0 ? round((float)str_replace(',', '.', $this->_conf->getStoreConfig('upslabel/weightdimension/packweight', $this->storeId)), 1) : '0';
        $defParArr_1['additionalhandling'] = $this->_conf->getStoreConfig('upslabel/ratepayment/additionalhandling', $this->storeId);
        $defParArr_1['dimansion_id'] = $this->_conf->getStoreConfig('upslabel/weightdimension/defaultdimensionsset', $this->storeId);
        $defParArr_1['width'] = $itemData !== NULL && isset($itemData['width']) ? $itemData['width'] : '';
        $defParArr_1['height'] = $itemData !== NULL && isset($itemData['height']) ? $itemData['height'] : '';
        $defParArr_1['length'] = $itemData !== NULL && isset($itemData['length']) ? $itemData['length'] : '';
        $defParArr_1['currencycode'] = $this->_conf->getStoreConfig('upslabel/ratepayment/currencycode', $this->storeId);
        $defParArr_1['cod'] = $this->_conf->getStoreConfig('upslabel/ratepayment/cod', $this->storeId) == 1 ? 1 : (($this->paymentmethod == 'cashondelivery' || $this->paymentmethod == 'phoenix_cashondelivery') ? 1 : 0);
        $defParArr_1['codfundscode'] = 0;
        $defParArr_1['codmonetaryvalue'] = $itemData !== NULL ? $itemData['price'] : $this->shipmentTotalPrice;
        $defParArr_1['insuredmonetaryvalue'] = $this->_conf->getStoreConfig('upslabel/ratepayment/insured_automaticaly', $this->storeId) == 1 ? ($itemData !== NULL ? $itemData['price'] : $this->shipmentTotalPrice) : 0;
        return ($defParArr_1);
    }

    public function getShipRate($lbl)
    {
        return $lbl->getShipRate();
    }
    public function getTIT($lbl, $weightSum)
    {
        return $lbl->timeInTransit($weightSum);
    }
    public function getLabel($order, $type, $shipmentId = NULL, $params)
    {
        if ($this->order === NULL) {
            $this->order = $order;
        }
        unset($order);
        $this->type = $type;
        unset($type);
        $this->shipmentId = $shipmentId;
        unset($shipmentId);
        if ($this->shipmentId !== NULL) {
            $this->shipment = $this->objectManager->get('Magento\Sales\Model\Order\Shipment')->load($this->shipmentId);
        }

        /*multistore*/
        $this->storeId = $this->order->getStoreId();
        /*multistore*/

        $lbl = $this->objectManager->get('Infomodus\Upslabel\Model\Ups');

        $lbl = $this->setParams($lbl, $params, $params['package']);
        $upsl2 = NULL;
        if ($this->type == 'shipment' || $this->type == 'invert') {
            $upsl = [];
            $upsl[0] = $lbl->getShip($this->type);
            if (isset($params['default_return']) && $params['default_return'] == 1) {
                $lbl->serviceCode = array_key_exists('default_return_servicecode', $params) ? $params['default_return_servicecode'] : '';
                $upsl2 = [];
                foreach ($params['package'] AS $package) {
                    $lbl->packages[0] = $package;
                    $upsl2[] = $lbl->getShipFrom();
                }
            }
        } else if ($this->type == 'refund') {
            $upsl = [];
            foreach ($params['package'] AS $package) {
                $lbl->packages[0] = $package;
                $upsl[] = $lbl->getShipFrom();
            }
        } else if ($this->type == 'ajaxprice_shipment') {
            $upsl = $lbl->getShipPrice($this->type);
            return $upsl;
        } else if ($this->type == 'ajaxprice_invert') {
            $upsl = $lbl->getShipPrice($this->type);
            return $upsl;
        } else if ($this->type == 'ajaxprice_refund') {
            $upsl = [];
            foreach ($params['package'] AS $package) {
                $lbl->packages[0] = $package;
                $upsl[] = $lbl->getShipPriceFrom($this->type);
            }
            return $upsl;
        }

        $this->saveDB($upsl, $upsl2, $params);
        if (!array_key_exists('error', $upsl) || !$upsl['error']) {
            $this->error = [];
        } else {
            $this->error = $upsl;
        }
        return TRUE;
    }

    public
    function setParams($lbl, $params, $packages)
    {
        if($lbl === NULL){
            $lbl = $this->objectManager->get('Infomodus\Upslabel\Model\Ups');
        }
        $configOptions = new \Infomodus\Upslabel\Model\Config\Options($this->_context, $this->objectManager);
        $configMethod = new \Infomodus\Upslabel\Model\Config\Upsmethod;
        $lbl->_handy = $this;
        $lbl->packages = $packages;

        $lbl->accessLicenseNumber = $this->_conf->getStoreConfig('upslabel/credentials/accesslicensenumber', $this->storeId);
        $lbl->userId = $this->_conf->getStoreConfig('upslabel/credentials/userid', $this->storeId);
        $lbl->password = $this->_conf->getStoreConfig('upslabel/credentials/password', $this->storeId);
        $lbl->shipperNumber = $this->_conf->getStoreConfig('upslabel/credentials/shippernumber', $this->storeId);

        $lbl->shipmentDescription = isset($params['shipmentdescription']) ? $this->_conf->escapeXML($params['shipmentdescription']) : '';
        $lbl->shipperName = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $params['shipper_no'] . '/companyname', $this->storeId));
        $lbl->shipperAttentionName = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $params['shipper_no'] . '/attentionname', $this->storeId));
        $lbl->shipperPhoneNumber = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $params['shipper_no'] . '/phonenumber', $this->storeId));
        $lbl->shipperAddressLine1 = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $params['shipper_no'] . '/addressline1', $this->storeId));
        $lbl->shipperCity = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $params['shipper_no'] . '/city', $this->storeId));
        $lbl->shipperStateProvinceCode = $this->_conf->escapeXML($configOptions->getProvinceCode($this->_conf->getStoreConfig('upslabel/address_' . $params['shipper_no'] . '/stateprovincecode', $this->storeId), $this->_conf->getStoreConfig('upslabel/address_' . $params['shipper_no'] . '/countrycode', $this->storeId)));
        $lbl->shipperPostalCode = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $params['shipper_no'] . '/postalcode', $this->storeId));
        $lbl->shipperCountryCode = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $params['shipper_no'] . '/countrycode', $this->storeId));

        $lbl->shiptoCompanyName = $this->_conf->escapeXML($params['shiptocompanyname']);
        $lbl->shiptoAttentionName = $this->_conf->escapeXML($params['shiptoattentionname']);
        $lbl->shiptoPhoneNumber = $this->_conf->escapeXML($params['shiptophonenumber']);
        $lbl->shiptoAddressLine1 = trim($this->_conf->escapeXML($params['shiptoaddressline1']));
        $lbl->shiptoAddressLine2 = trim($this->_conf->escapeXML($params['shiptoaddressline2']));
        $lbl->shiptoCity = $this->_conf->escapeXML($params['shiptocity']);
        $lbl->shiptoStateProvinceCode = $this->_conf->escapeXML($configOptions->getProvinceCode($params['shiptostateprovincecode'], $params['shiptocountrycode']));
        $lbl->shiptoPostalCode = $this->_conf->escapeXML($params['shiptopostalcode']);
        $lbl->shiptoCountryCode = $this->_conf->escapeXML($params['shiptocountrycode']);
        $lbl->residentialAddress = isset($params['residentialaddress']) ? $params['residentialaddress'] : '';

        $lbl->shipfromCompanyName = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $params['shipfrom_no'] . '/companyname', $this->storeId));
        $lbl->shipfromAttentionName = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $params['shipfrom_no'] . '/attentionname', $this->storeId));
        $lbl->shipfromPhoneNumber = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $params['shipfrom_no'] . '/phonenumber', $this->storeId));
        $lbl->shipfromAddressLine1 = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $params['shipfrom_no'] . '/addressline1', $this->storeId));
        $lbl->shipfromCity = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $params['shipfrom_no'] . '/city', $this->storeId));
        $lbl->shipfromStateProvinceCode = $this->_conf->escapeXML($configOptions->getProvinceCode($this->_conf->getStoreConfig('upslabel/address_' . $params['shipfrom_no'] . '/stateprovincecode', $this->storeId), $this->_conf->getStoreConfig('upslabel/address_' . $params['shipfrom_no'] . '/countrycode', $this->storeId)));
        $lbl->shipfromPostalCode = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $params['shipfrom_no'] . '/postalcode', $this->storeId));
        $lbl->shipfromCountryCode = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $params['shipfrom_no'] . '/countrycode', $this->storeId));

        $lbl->serviceCode = array_key_exists('serviceCode', $params) ? $params['serviceCode'] : '';
        $lbl->serviceDescription = $configMethod->getUpsMethodName(array_key_exists('serviceCode', $params) ? $params['serviceCode'] : '');

        $lbl->weightUnits = array_key_exists('weightunits', $params) ? $params['weightunits'] : '';

        $lbl->includeDimensions = array_key_exists('includedimensions', $params) ? $params['includedimensions'] : 0;
        $lbl->unitOfMeasurement = array_key_exists('unitofmeasurement', $params) ? $params['unitofmeasurement'] : '';

        $lbl->codYesNo = array_key_exists('cod', $params) ? $params['cod'] : '';
        $lbl->currencyCode = array_key_exists('currencycode', $params) ? $params['currencycode'] : '';
        $lbl->codMonetaryValue = array_key_exists('codmonetaryvalue', $params) ? $params['codmonetaryvalue'] : '';
        $lbl->codFundsCode = array_key_exists('codfundscode', $params) ? $params['codfundscode'] : '';
        $lbl->carbonNeutral = array_key_exists('carbon_neutral', $params) ? $params['carbon_neutral'] : '';

        if (array_key_exists('qvn', $params) && $params['qvn'] > 0) {
            $lbl->qvn = 1;
            $lbl->qvnCode = $params['qvn_code'];
            if(isset($params['qvn_lang'])) {
                $lbl->qvnLang = $params['qvn_lang'];
            }
        }
        $lbl->qvnEmailShipper = $params['qvn_email_shipper'];
        $lbl->qvnEmailShipto = $params['qvn_email_shipto'];

        if ($lbl->shipfromCountryCode != $lbl->shiptoCountryCode) {
            $lbl->shipmentcharge = array_key_exists('shipmentcharge', $params) ? $params['shipmentcharge'] : 0;
        }

        if (array_key_exists('invoicelinetotalyesno', $params) && $params['invoicelinetotalyesno'] > 0) {
            $lbl->invoicelinetotal = array_key_exists('invoicelinetotal', $params) ? $params['invoicelinetotal'] : '';
        } else {
            $lbl->invoicelinetotal = '';
        }
        if (isset($params['upsaccount']) && $params['upsaccount'] != 0) {
            $lbl->upsAccount = 1;
            $lbl->accountData = $this->objectManager->get('Infomodus\Upslabel\Model\Account')->load($params['upsaccount']);
        }

        if ($params['adult'] != 1 || strpos($this->_conf->getStoreConfig('upslabel/quantum/adult_allow_country', $this->storeId), $lbl->shiptoCountryCode) !== FALSE) {
            $lbl->adult = $this->_conf->escapeXML($params['adult']);
        }

        $lbl->internationalInvoice = 0;
        if (isset($params['international_invoice']) && $params['international_invoice'] == 1) {
            $lbl->internationalInvoice = $this->_conf->escapeXML($params['international_invoice']);
            $lbl->internationalComments = $this->_conf->escapeXML($params['international_comments']);
            $lbl->internationalInvoicenumber = $this->_conf->escapeXML($params['international_invoicenumber']);
            $lbl->internationalInvoicedate = str_replace("-", "", $this->_conf->escapeXML($params['international_invoicedate']));
            $lbl->internationalReasonforexport = $this->_conf->escapeXML($params['international_reasonforexport']);
            $lbl->internationalTermsofshipment = $this->_conf->escapeXML($params['international_termsofshipment']);
            $lbl->internationalPurchaseordernumber = $this->_conf->escapeXML($params['international_purchaseordernumber']);
            $lbl->internationalProducts = isset($params['international_products'])?$params['international_products']:[];
            $lbl->internationalSoldTo = isset($params['international_sold_to'])?$params['international_sold_to']:"shipto";
        }

        $lbl->testing = $params['testing'];

        $lbl->saturdayDelivery = isset($params['saturday_delivery']) ? $params['saturday_delivery'] : "";
        $lbl->negotiatedRates = $this->_conf->getStoreConfig('upslabel/ratepayment/negotiatedratesindicator', $this->storeId);
        if (isset($params['accesspoint'])) {
            $lbl->accesspoint = $params['accesspoint'];
            if ($lbl->accesspoint == 1) {
                $lbl->accesspointType = $this->_conf->escapeXML($params['accesspoint_type']);
                $lbl->accesspointName = isset($params['accesspoint_name']) ? $this->_conf->escapeXML($params['accesspoint_name']) : '';
                $lbl->accesspointAtname = isset($params['accesspoint_atname']) ? $this->_conf->escapeXML($params['accesspoint_atname']) : '';
                $lbl->accesspointAppuid = isset($params['accesspoint_appuid']) ? $this->_conf->escapeXML($params['accesspoint_appuid']) : '';
                $lbl->accesspointStreet = $this->_conf->escapeXML($params['accesspoint_street']);
                $lbl->accesspointStreet1 = isset($params['accesspoint_street1']) ? $this->_conf->escapeXML($params['accesspoint_street1']) : '';
                $lbl->accesspointStreet2 = isset($params['accesspoint_street2']) ? $this->_conf->escapeXML($params['accesspoint_street2']) : '';
                $lbl->accesspointCity = $this->_conf->escapeXML($params['accesspoint_city']);
                $lbl->accesspointProvincecode = isset($params['accesspoint_provincecode']) ? $params['accesspoint_provincecode'] : '';
                $lbl->accesspointPostal = $this->_conf->escapeXML($params['accesspoint_postal']);
                $lbl->accesspointCountry = $this->_conf->escapeXML($params['accesspoint_country']);
            }
        }
        return $lbl;
    }

    public
    function saveDB($upsl, $upsl2 = NULL, $params)
    {
        if ($this->order->getId() > 0) {
            $colls2 = $this->objectManager->get('Infomodus\Upslabel\Model\Items')->getCollection()->addFieldToFilter('order_id', $this->order->getId())->addFieldToFilter('type', $this->type)->addFieldToFilter('lstatus', 1);
            if (count($colls2) > 0) {
                foreach ($colls2 AS $c) {
                    $c->delete();
                }
            }
            $upsl0 = $upsl;
            $upsl = NULL;
            foreach ($upsl0 AS $upsl) {
                if (!array_key_exists('error', $upsl) || !$upsl['error']) {
                    if ($this->shipmentId === NULL && $this->type == "shipment") {
                        if ($this->order->canShip() && count($this->order->getShipmentsCollection())==0) {
                            /*$items=[];
                            foreach($this->order->getAllItems() AS $item){
                                $items[$item->getId()] = $item->getQtyToShip();
                            }*/
                            $shipmentLoader = $this->shipmentLoaderFactory->create();
                            $shipmentLoader->setOrderId($this->order->getId());
                            /*$shipmentLoader->setShipment($items);*/
                            if($this->_registry->registry('current_shipment')) {
                                $this->_registry->unregister('current_shipment');
                            }
                            $shipment = $shipmentLoader->load();
                            if ($shipment) {
                                $shipment->register();
                                $shipment->getOrder()->setIsInProcess(true);
                                $transactionSave = $this->objectManager->create(
                                    'Magento\Framework\DB\Transaction'
                                );
                                $transactionSave->addObject(
                                    $shipment
                                )->addObject(
                                    $shipment->getOrder()
                                );
                                $transactionSave->save();
                            }
                            $this->shipment = $this->objectManager->get('Magento\Sales\Model\Order\Shipment')->load($shipment->getId());
                            $this->shipmentId = $this->shipment->getId();
                        } else {
                            $this->shipment = $this->order->getShipmentsCollection()->getFirstItem();
                            $this->shipmentId = $this->shipment->getId();
                        }
                    }
                    if ($this->_conf->getStoreConfig('upslabel/additional_settings/orderstatuses', $this->storeId) != '') {
                        $this->order->setStatus($this->_conf->getStoreConfig('upslabel/additional_settings/orderstatuses', $this->storeId), true)->save();
                        $this->order->save();
                    }

                    foreach ($upsl['arrResponsXML'] AS $upsl_one) {
                        $upslabel = $this->objectManager->create('Infomodus\Upslabel\Model\Items');
                        $upslabel->setTitle('Order ' . $this->order->getIncrementId() . ' TN' . $upsl_one['trackingnumber']);
                        $upslabel->setOrderId($this->order->getId());
                        $upslabel->setOrderIncrementId($this->order->getIncrementId());
                        $upslabel->setShipmentId($this->shipmentId);
                        if ($this->type == "shipment") {
                            $upslabel->setShipmentIncrementId($this->shipment->getIncrementId());
                        }
                        $upslabel->setType($this->type);
                        $upslabel->setType2($this->type);
                        $upslabel->setTrackingnumber($upsl_one['trackingnumber']);
                        $upslabel->setShipmentidentificationnumber($upsl['shipidnumber']);
                        $upslabel->setShipmentidentificationnumber2($upsl['shipidnumber']);
                        $upslabel->setShipmentdigest($upsl['digest']);
                        $upslabel->setLabelname('label' . $upsl_one['trackingnumber'] . '.' . strtolower($upsl_one['type_print']));
                        $upslabel->setStatustext(__('Successfully'));
                        $upslabel->setTypePrint($upsl_one['type_print']);
                        $upslabel->setLstatus(0);
                        $upslabel->setPrice($upsl['price']['price']);
                        $upslabel->setCurrency($upsl['price']['currency']);
                        /*multistore*/
                        $upslabel->setStoreId($this->order->getStoreId());
                        /*multistore*/
                        if (isset($upsl['inter_invoice']) && $upsl['inter_invoice'] !== NULL) {
                            $upslabel->setInternationalInvoice(1);
                        }
                        $upslabel->setCreatedTime(Date("Y-m-d H:i:s"));
                        $upslabel->setUpdateTime(Date("Y-m-d H:i:s"));
                        if ($upslabel->save() !== FALSE && $this->_conf->getStoreConfig('upslabel/printing/automatic_printing', $this->storeId) == 1 && $this->_conf->getStoreConfig('upslabel/printing/printer', $this->storeId) != "GIF") {
                            $this->_conf->sendPrint($upsl_one['graphicImage'], $this->storeId);
                        }
                        $this->label[] = $upslabel;
                    }
                    $path = $this->_conf->getBaseDir('media') . '/upslabel/inter_pdf/';
                    if (!is_dir($path)) {
                        mkdir($path, 0777);
                    }
                    if (isset($upsl['inter_invoice']) && $upsl['inter_invoice'] !== NULL) {
                        file_put_contents($path . $upsl['shipidnumber'] . ".pdf", base64_decode($upsl['inter_invoice']));
                    }
                    $pathTurnInPage = $this->_conf->getBaseDir('media') . '/upslabel/turn_in_page/';
                    if (!is_dir($pathTurnInPage)) {
                        mkdir($pathTurnInPage, 0777);
                    }
                    if (isset($upsl['turn_in_page']) && $upsl['turn_in_page'] !== NULL) {
                        file_put_contents($pathTurnInPage . $upsl['shipidnumber'] . ".html", base64_decode($upsl['turn_in_page']));
                    }
                    if (isset($params['default_return']) && $params['default_return'] == 1 && $this->type != "refund") {
                        $upsl3 = $upsl2;
                        $upsl2 = NULL;
                        foreach ($upsl3 AS $upsl2) {
                            if (isset($upsl2) && !empty($upsl2) && (!array_key_exists('error', $upsl2) || !$upsl2['error'])) {
                                foreach ($upsl2['arrResponsXML'] AS $upsl_one) {
                                    $upslabel = $this->objectManager->create('Infomodus\Upslabel\Model\Items');
                                    $upslabel->setTitle('Order ' . $this->order->getIncrementId() . ' TN' . $upsl_one['trackingnumber']);
                                    $upslabel->setOrderId($this->order->getId());
                                    $upslabel->setOrderIncrementId($this->order->getIncrementId());
                                    $upslabel->setShipmentId($this->shipmentId);
                                    if ($this->type == "shipment") {
                                        $upslabel->setShipmentIncrementId($this->shipment->getIncrementId());
                                    }
                                    $upslabel->setType($this->type);
                                    $upslabel->setType2('refund');
                                    $upslabel->setTrackingnumber($upsl_one['trackingnumber']);
                                    $upslabel->setShipmentidentificationnumber($upsl['shipidnumber']);
                                    $upslabel->setShipmentidentificationnumber2($upsl2['shipidnumber']);
                                    $upslabel->setShipmentdigest($upsl2['digest']);
                                    $upslabel->setLabelname('label' . $upsl_one['trackingnumber'] . '.' . strtolower($upsl_one['type_print']));
                                    $upslabel->setStatustext(__('Successfully'));
                                    $upslabel->setTypePrint($upsl_one['type_print']);
                                    $upslabel->setLstatus(0);
                                    $upslabel->setPrice($upsl2['price']['price']);
                                    $upslabel->setCurrency($upsl2['price']['currency']);
                                    /*multistore*/
                                    $upslabel->setStoreId($this->order->getStoreId());
                                    /*multistore*/
                                    $upslabel->setCreatedTime(Date("Y-m-d H:i:s"));
                                    $upslabel->setUpdateTime(Date("Y-m-d H:i:s"));
                                    if ($upslabel->save() !== FALSE && $this->_conf->getStoreConfig('upslabel/printing/automatic_printing', $this->storeId) == 1 && $this->_conf->getStoreConfig('upslabel/printing/printer', $this->storeId) != "GIF") {
                                        $this->_conf->sendPrint($upsl_one['graphicImage'], $this->storeId);
                                    }
                                    $this->label2[] = $upslabel;
                                }
                                if (isset($params['addtrack']) && $params['addtrack'] == 1 && $this->type == 'shipment') {
                                    $trTitle = 'United Parcel Service (return)';
                                    if ($this->shipment) {
                                        foreach ($upsl2['arrResponsXML'] AS $upsl_one1) {
                                            $track = $this->objectManager->create('Magento\Sales\Model\Order\Shipment\Track')
                                                ->setNumber(trim($upsl_one1['trackingnumber']))
                                                ->setCarrierCode('ups')
                                                ->setTitle($trTitle);
                                            $this->shipment->addTrack($track);
                                        }
                                    }
                                }
                            } else {
                                $upslabel = $this->objectManager->create('Infomodus\Upslabel\Model\Items');
                                $upslabel->setTitle('Order ' . $this->order->getIncrementId());
                                $upslabel->setOrderId($this->order->getId());
                                $upslabel->setOrderIncrementId($this->order->getIncrementId());
                                $upslabel->setShipmentId($this->shipmentId);
                                $upslabel->setType($this->type);
                                $upslabel->setType2('refund');
                                $upslabel->setStatustext($upsl2['error']);
                                if(isset($upsl2['request']) && isset($upsl2['response'])) {
                                    $upslabel->setXmllog($upsl2['request'] . $upsl2['response']);
                                }
                                $upslabel->setLstatus(1);
                                /*multistore*/
                                $upslabel->setStoreId($this->order->getStoreId());
                                /*multistore*/
                                $upslabel->setCreatedTime(Date("Y-m-d H:i:s"));
                                $upslabel->setUpdateTime(Date("Y-m-d H:i:s"));
                                $upslabel->save();
                                $this->label2[] = $upslabel;
                            }
                        }
                    }

                    if (isset($params['addtrack']) && $params['addtrack'] == 1 && $this->type == 'shipment') {
                        $trTitle = 'United Parcel Service';
                        if ($this->shipment) {
                            foreach ($upsl['arrResponsXML'] AS $upsl_one1) {
                                $track = $this->objectManager->create('Magento\Sales\Model\Order\Shipment\Track')
                                    ->setNumber(trim($upsl_one1['trackingnumber']))
                                    ->setCarrierCode('ups')
                                    ->setTitle($trTitle);
                                $this->shipment->addTrack($track);
                            }
                            $this->shipment->save();
                            if ($this->_conf->getStoreConfig('upslabel/frontend_autocreate_label/track_send', $this->storeId) == 1) {
                                $this->objectManager->create('Magento\Sales\Model\Service\ShipmentService')
                                    ->notify($this->shipment->getId());
                            }
                        }
                    }
                } else {
                    $upslabel = $this->objectManager->create('Infomodus\Upslabel\Model\Items');
                    $upslabel->setTitle('Order ' . $this->order->getIncrementId());
                    $upslabel->setOrderId($this->order->getId());
                    $upslabel->setOrderIncrementId($this->order->getIncrementId());
                    $upslabel->setShipmentId($this->shipmentId);
                    $upslabel->setType($this->type);
                    $upslabel->setType2($this->type);
                    $upslabel->setStatustext($upsl['error']);
                    if(isset($upsl['request']) && isset($upsl['response'])) {
                        $upslabel->setXmllog($upsl['request'] . $upsl['response']);
                    }
                    $upslabel->setLstatus(1);
                    /*multistore*/
                    $upslabel->setStoreId($this->order->getStoreId());
                    /*multistore*/
                    $upslabel->setCreatedTime(Date("Y-m-d H:i:s"));
                    $upslabel->setUpdateTime(Date("Y-m-d H:i:s"));
                    $upslabel->save();
                    $this->label[] = $upslabel;
                }
            }
            return true;
        }
        return false;
    }

    public function deleteLabel($shipidnumber = NULL, $type = 'shipidnumber')
    {
        if ($shipidnumber !== NULL) {
            if ($type == 'shipidnumber') {
                $labels = $this->objectManager->create('Infomodus\Upslabel\Model\Items')->getCollection()->addFieldToFilter('shipmentidentificationnumber', ['in' => $shipidnumber]);
            } else if ($type == 'label_ids') {
                $labels = $this->objectManager->create('Infomodus\Upslabel\Model\Items')->getCollection()->addFieldToFilter('upslabel_id', ['in' => $shipidnumber]);
            }
            if (count($labels) > 0) {
                $this->order = NULL;
                $this->shipmentId = NULL;
                foreach ($labels AS $model) {
                    if ($this->order === NULL) {
                        $this->order = $this->objectManager->get('Magento\Sales\Model\Order')->load($model->getOrderId());
                    }
                    if ($model->getShipmentId() > 0 && $this->shipmentId === NULL) {
                        $this->shipmentId = $model->getShipmentId();
                    }
                    $this->type = $model->getType();
                    $this->storeId = $this->order->getStoreId();

                    if ($model->getLstatus() == 0) {
                        $lbl = $this->objectManager->create('Infomodus\Upslabel\Model\Ups');

                        $lbl->packagingReferenceNumberCode = $this->_conf->getStoreConfig('upslabel/packaging/packagingreferencenumbercode', $this->storeId);
                        $lbl->testing = $this->_conf->getStoreConfig('upslabel/testmode/testing', $this->storeId);
                        /*multistore*/
                        $lbl->storeId = $this->storeId;
                        /*multistore*/
                        $this->intermediate($this->order, $model->getType(), $this->shipmentId);
                        $this->setParams($lbl, $this->defConfParams, $this->defPackageParams);
                        $result = $lbl->deleteLabel($model->getShipmentidentificationnumber2());
                        if ($result !== NULL) {
                            $this->messageManager->addError('Delete UPS label. Tracking Number: ' . $model->getTrackingnumber() . '. Error: ' . $result['error']);
                        }

                        if (file_exists($this->_conf->getBaseDir('media') . '/upslabel/label/' . $model->getLabelname())) {
                            unlink($this->_conf->getBaseDir('media') . '/upslabel/label/' . $model->getLabelname());
                        }
                        if (file_exists($this->_conf->getBaseDir('media') . '/upslabel/label/' . $model->getTrackingnumber() . '.html')) {
                            unlink($this->_conf->getBaseDir('media') . '/upslabel/label/' . $model->getTrackingnumber() . '.html');
                        }
                        if (file_exists($this->_conf->getBaseDir('media') . '/upslabel/label/' . "HVR" . $model->getShipmentidentificationnumber2() . ".html")) {
                            unlink($this->_conf->getBaseDir('media') . '/upslabel/label/' . "HVR" . $model->getShipmentidentificationnumber2() . ".html");
                        }
                        if (file_exists($this->_conf->getBaseDir('media') . '/upslabel/inter_pdf/' . $model->getTrackingnumber() . ".pdf")) {
                            unlink($this->_conf->getBaseDir('media') . '/upslabel/inter_pdf/' . $model->getTrackingnumber() . ".pdf");
                        }
                        if ($model->getShipmentId() > 0) {
                            $shipm = $this->objectManager->get('Magento\Sales\Model\Order\ShipmentRepository')->get($model->getShipmentId());
                            $tracks = $shipm->getAllTracks();
                            foreach ($tracks as $track) {
                                if ($track->getNumber() == $model->getTrackingnumber()) {
                                    $track->delete();
                                }
                            }
                        }
                    }
                    $model->delete();
                }
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }

    public function setPickup($data)
    {
        /*multistore*/
        $this->storeId = isset($data['store']) ? $data['store'] : NULL;
        /*multistore*/
        $this->pickup = $this->objectManager->create('Infomodus\Upslabel\Model\Ups');
        $this->pickup->_handy = $this;
        $this->pickup->accessLicenseNumber = $this->_conf->getStoreConfig('upslabel/credentials/accesslicensenumber', $this->storeId);
        $this->pickup->userId = $this->_conf->getStoreConfig('upslabel/credentials/userid', $this->storeId);
        $this->pickup->password = $this->_conf->getStoreConfig('upslabel/credentials/password', $this->storeId);
        $this->pickup->shipperNumber = $this->_conf->getStoreConfig('upslabel/credentials/shippernumber', $this->storeId);

        $this->pickup->ratePickupIndicator = "N"/*$data['RatePickupIndicator']*/
        ;
        $this->pickup->shipperCountryCode = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $this->_conf->getStoreConfig('upslabel/shipping/defaultshipper', $this->storeId) . '/countrycode', $this->storeId));
        $this->pickup->closeTime = $data['CloseTime'];
        $this->pickup->readyTime = $data['ReadyTime'];
        $this->pickup->pickupDateYear = $data['PickupDateYear'];
        $this->pickup->pickupDateMonth = $data['PickupDateMonth'];
        $this->pickup->pickupDateDay = $data['PickupDateDay'];
        if (isset($data['oadress']['OtherAddress']) && $data['oadress']['OtherAddress'] == 1) {
            $this->pickup->shipfromCompanyName = $this->_conf->escapeXML($data['oadress']['companyname']);
            $this->pickup->shipfromAttentionName = $this->_conf->escapeXML($data['oadress']['attentionname']);
            $this->pickup->shipfromAddressLine1 = $this->_conf->escapeXML($data['oadress']['addressline1']);
            $this->pickup->room = $this->_conf->escapeXML($data['oadress']['room']);
            $this->pickup->floor = $this->_conf->escapeXML($data['oadress']['floor']);
            $this->pickup->shipfromCity = $this->_conf->escapeXML($data['oadress']['city']);
            $this->pickup->shipfromStateProvinceCode = $this->_conf->escapeXML($data['oadress']['stateprovincecode']);
            $this->pickup->urbanization = $this->_conf->escapeXML($data['oadress']['urbanization']);
            $this->pickup->shipfromPostalCode = $this->_conf->escapeXML($data['oadress']['postalcode']);
            $this->pickup->shipfromCountryCode = $this->_conf->escapeXML($data['oadress']['countrycode']);
            $this->pickup->residential = $this->_conf->escapeXML($data['oadress']['residential']);
            $this->pickup->pickupPoint = $this->_conf->escapeXML($data['oadress']['pickup_point']);
            $this->pickup->shipfromPhoneNumber = $this->_conf->escapeXML($data['oadress']['phonenumber']);
        } else {
            $this->pickup->shipfromCompanyName = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $data['ShipFrom'] . '/companyname', $this->storeId));
            $this->pickup->shipfromAttentionName = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $data['ShipFrom'] . '/attentionname', $this->storeId));
            $this->pickup->shipfromAddressLine1 = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $data['ShipFrom'] . '/addressline1', $this->storeId));
            $this->pickup->room = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $data['ShipFrom'] . '/room', $this->storeId));
            $this->pickup->floor = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $data['ShipFrom'] . '/floor', $this->storeId));
            $this->pickup->shipfromCity = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $data['ShipFrom'] . '/city', $this->storeId));
            $this->pickup->shipfromStateProvinceCode = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $data['ShipFrom'] . '/stateprovincecode', $this->storeId));
            $this->pickup->urbanization = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $data['ShipFrom'] . '/urbanization', $this->storeId));
            $this->pickup->shipfromPostalCode = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $data['ShipFrom'] . '/postalcode', $this->storeId));
            $this->pickup->shipfromCountryCode = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $data['ShipFrom'] . '/countrycode', $this->storeId));
            $this->pickup->residential = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $data['ShipFrom'] . '/residential', $this->storeId));
            $this->pickup->pickupPoint = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $data['ShipFrom'] . '/pickup_point', $this->storeId));
            $this->pickup->shipfromPhoneNumber = $this->_conf->escapeXML($this->_conf->getStoreConfig('upslabel/address_' . $data['ShipFrom'] . '/phonenumber', $this->storeId));
        }
        $this->pickup->alternateAddressIndicator = $data['AlternateAddressIndicator'];
        $this->pickup->serviceCode = $data['ServiceCode'];
        $this->pickup->quantity = $data['Quantity'];
        $this->pickup->destinationCountryCode = $data['DestinationCountryCode'];
        $this->pickup->containerCode = $data['ContainerCode'];
        $this->pickup->weight = $data['Weight'];
        $this->pickup->unitOfMeasurement = $data['UnitOfMeasurement'];
        $this->pickup->overweightIndicator = $data['OverweightIndicator'];
        $this->pickup->paymentMethod = $data['PaymentMethod'];
        $this->pickup->specialInstruction = $data['SpecialInstruction'];
        $this->pickup->referenceNumber = $data['ReferenceNumber'];
        $this->pickup->notification = $data['Notification'];
        $this->pickup->confirmationEmailAddress = $data['ConfirmationEmailAddress'];
        $this->pickup->undeliverableEmailAddress = $data['UndeliverableEmailAddress'];
        $this->pickup->testing = $this->_conf->getStoreConfig('upslabel/testmode/testing', $this->storeId);
    }

    public function cancelPickup($id)
    {
        $model = $this->objectManager->get('Infomodus\Upslabel\Model\Pickup')->load($id);
        $data = $model->getData();
        /*multistore*/
        $this->storeId = $model->getStore();
        /*multistore*/
        if ($this->pickup === NULL) {
            $this->pickup = $this->objectManager->create('Infomodus\Upslabel\Model\Ups');
        }
        $this->pickup->_handy = $this;
        $this->pickup->accessLicenseNumber = $this->_conf->getStoreConfig('upslabel/credentials/accesslicensenumber', $this->storeId);
        $this->pickup->userId = $this->_conf->getStoreConfig('upslabel/credentials/userid', $this->storeId);
        $this->pickup->password = $this->_conf->getStoreConfig('upslabel/credentials/password', $this->storeId);
        $this->pickup->shipperNumber = $this->_conf->getStoreConfig('upslabel/credentials/shippernumber', $this->storeId);
        $this->pickup->testing = $this->_conf->getStoreConfig('upslabel/testmode/testing', $this->storeId);
        $xml = simplexml_load_string($data['pickup_response']);
        $soap = $xml->children('soapenv', true)->Body[0];
        $PRN = $soap->children('pkup', true)->PickupCreationResponse[0]->PRN;
        $this->pickup->cancelPickup($PRN);
    }
}